SystemOrganization addCategory: #'Rizel-Builder'!
SystemOrganization addCategory: #'Rizel-Builder-Tests'!

OrderedCollection subclass: #RzVector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Builder'!

!RzVector class methodsFor: 'factory-methods' stamp: 'JuanPabloSandovalAlcocer 7/5/2012 16:57'!
<<< anObject
	"magic builder"
	^ self values: (OrderedCollection new add:anObject; yourself).! !

!RzVector class methodsFor: 'factory-methods' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:25'!
<== anObject
	"magic builder"
	^ self values: (OrderedCollection new add:anObject; yourself).! !

!RzVector class methodsFor: 'factory-methods' stamp: 'JuanPabloSandovalA 6/24/2012 19:30'!
values: aCollection 
	| instance |
	instance := self new.
	instance addAll: aCollection.
	^ instance! !

!RzVector methodsFor: 'action' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:24'!
+ anObject
	""
	self add: anObject.! !

!RzVector methodsFor: 'action' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:33'!
- anObject
	""
	self remove: anObject ifAbsent: [ ].! !

!RzVector methodsFor: 'comparing' stamp: 'JuanPabloSandovalA 6/24/2012 19:24'!
= aVector 
	| piv |
	self class = aVector class
		ifTrue: [self size = aVector size
			ifTrue: [
				piv := 1.
				self do: [:val | 
					val = (aVector at: piv) ifFalse: [^ false].
					piv := piv + 1].
			^ true]].
	^ false.! !

!RzVector methodsFor: 'action' stamp: 'JuanPabloSandovalAlcocer 7/5/2012 16:57'!
>< anObject
	""
	self add: anObject.! !

TestCase subclass: #RzBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Builder-Tests'!

!RzBuilderTest commentStamp: '<historical>' prior: 0!
A RzBuilderTest is a test class for testing the behavior of RzBuilder!

!RzBuilderTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 19:14'!
testCombinations
	|builder|
	builder := RzBuilder new.
	builder define:#input named:#numbers with: #(1 2 3).
	self assert: (builder combinations size = 3).
	builder define:#input named:#numbers2 with:#(4 5 6).
	self assert: (builder combinations size = 9).! !

!RzBuilderTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 20:50'!
testCombinations2
	""
	|builder combs|
	builder := RzBuilder new.
	builder define:#input named:#x with: #(1 2).
	builder define:#input named:#y with: #(3 4).
	
	combs := builder combinations.
	self assert: (combs first asArray = #(1 3)).
	self assert: (combs second asArray = #(1 4)).
	self assert: (combs third asArray = #(2 3)).
	self assert: (combs fourth asArray = #(2 4)).! !

!RzBuilderTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 20:50'!
testExecute
	|builder combs|
	builder := RzBuilder new.
	builder define:#input named:#x with: #(1 2).
	builder define:#input named:#y with: #(3 4).
	combs := OrderedCollection new.
	
	builder execute: [ :x :y | combs add: (OrderedCollection new add:x;add:y;yourself)].
	
	self assert: (combs first asArray = #(1 3)).
	self assert: (combs second asArray = #(1 4)).
	self assert: (combs third asArray = #(2 3)).
	self assert: (combs fourth asArray = #(2 4)).! !

!RzBuilderTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 20:43'!
testInputs
	|builder|
	builder := RzBuilder new.
	builder define:#input named:#a with: #(1 2 3).
	builder define:#input named:#b with:#(4 5 6).
	self assert: (builder inputs size = 2).! !

!RzBuilderTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 20:52'!
testInputsOf
	|builder|
	builder := RzBuilder new.
	builder define:#input named:#a with: #(1 2).
	builder define:#input named:#b with:#(4 5 6).
	self assert: ((builder inputsOf:#a) size = 2).
	self assert: ((builder inputsOf:#b) size = 3).! !

!RzBuilderTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 20:46'!
testNew
	|builder|
	builder := RzBuilder new.
	self assert: (builder notNil).
	self assert: (builder spyProfiler = RzProfilerSpy).! !

TestCase subclass: #RzInputTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Builder-Tests'!

!RzInputTest commentStamp: '<historical>' prior: 0!
A RzInputTest is a test class for testing the behavior of RzInput!

!RzInputTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 19:05'!
testNew
	|input|
	input := RzInput named: #version.
	self assert: (input name = #version).! !

!RzInputTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 19:05'!
testValues
	|input|
	input := RzInput named: #numbers.
	input addValue: 1.
	input addValue: 2.
	self assert: (input values size = 2).! !

TestCase subclass: #RzResultSetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Builder-Tests'!

!RzResultSetTest commentStamp: '<historical>' prior: 0!
A RzResultSetTest is a test class for testing the behavior of RzResultSet!

!RzResultSetTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:56'!
testKeys
	|result keys|
	result := RzResultSet new.
	result key: 1 value: 20.
	result key: 2 value:30.
	keys := result keys.
	self assert: ( keys first = (RzVector <== 1)).
	self assert: ( keys second = (RzVector <== 2)).! !

!RzResultSetTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:42'!
testMax
	|result|
	result := RzResultSet new.
	result key: #(1) value: 20.
	result key: 2 value: 10.
	
	self assert: ( (result maxValue:[:value| value]) = 20).! !

!RzResultSetTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:50'!
testMin
	|result|
	result := RzResultSet new.
	result key: #(1) value: 20.
	result key: 2 value: 10.
	
	self assert: ( (result minValue:[:value| value]) = 10).! !

!RzResultSetTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:40'!
testSet
	|result|
	result := RzResultSet new.
	result key: #(1 2 3) value: 20.
	result key: (RzVector <== 1+2+3) value:30.
	
	self assert: ( (result at: #(1 2 3)) = 30).! !

!RzResultSetTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:55'!
testValues
	|result|
	result := RzResultSet new.
	result key: #(1 2 3) value: 20.
	result key: (RzVector <== 1+2+3) value:30.
	self assert: ( (RzVector values: (result values)) = (RzVector <== 20+30)).! !

TestCase subclass: #RzVectorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Builder-Tests'!

!RzVectorTest commentStamp: '<historical>' prior: 0!
A RzVectorTest is a test class for testing the behavior of RzVector!

!RzVectorTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:31'!
testBuilder
	""
	|vector|
	vector := RzVector <== 1.
	self assert: (vector size = 1).
	! !

!RzVectorTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:30'!
testEqual
	""
	|a b|
	a := RzVector <== 1+2+3+4.
	b := RzVector values: #(1 2 3 4).
	self assert: (a = b).
	! !

!RzVectorTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:31'!
testLess
	""
	|vector|
	vector := RzVector <== 1+2-3-2.
	self assert: (vector size = 1).
	! !

!RzVectorTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/5/2012 17:00'!
testLessSyntax
	""
	|vector|
	vector := RzVector <<<1><2><3><2.
	self assert: (vector size = 4).! !

!RzVectorTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:31'!
testPlus
	""
	|vector|
	vector := RzVector <== 1+2+3+4.
	self assert: (vector size = 4).
	! !

!RzVectorTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:30'!
testValues
	""
	|vector|
	vector := RzVector values: #(1 2 3 4).
	self assert: (vector size =4).
	! !

Object subclass: #RzBuilder
	instanceVariableNames: 'inputs packagePattern'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Builder'!

!RzBuilder methodsFor: 'combinations' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:54'!
combinations
	"return all combinations for inputs"
	^ self combinationsOf: inputs copy! !

!RzBuilder methodsFor: 'combinations' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:55'!
combinationsOf: aCollectionOfInputs 
	"return all combiantions for aCollectionOfInputs"
	| subComb first result |
	result := OrderedCollection new.
	aCollectionOfInputs isEmpty
		ifTrue: [^ result].
	first := aCollectionOfInputs first.
	aCollectionOfInputs removeFirst.
	subComb := self combinationsOf: aCollectionOfInputs.
	first values
		do: [:val | subComb isEmpty
				ifTrue: [result add: (OrderedCollection new add: val;
							 yourself)]
				ifFalse: [subComb
						do: [:subVal | result add: (OrderedCollection new add: val;
									 addAll: subVal;
									 yourself)]]].
	^ result! !

!RzBuilder methodsFor: 'inputs' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:30'!
define: aSymbol named: aString 
	"define a new dimension to the analisis"
	| variant |
	variant := self perform: aSymbol.
	variant name: aString.
	^ variant! !

!RzBuilder methodsFor: 'inputs' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:30'!
define: aSymbol named: aString with: values 
	"define a new dimension named aString with values"
	| variant |
	variant := self define: aSymbol named: aString.
	variant values: values.
	^ variant! !

!RzBuilder methodsFor: 'combinations' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:08'!
execute: block 
	"do a multimensional profiling"
	^ self execute: block in: RzResultSet new! !

!RzBuilder methodsFor: 'combinations' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 22:03'!
execute: block in: result
	"execute the block with all convinations and save the profiles in result"
	self combinations do: [:args | 
			| profile |
			profile := [block valueWithArguments: args] on:Error do:[ :ex| nil].
			result key: args value: profile]. 
	^ result.
		! !

!RzBuilder methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:58'!
initialize
	super initialize.
	inputs := OrderedCollection new! !

!RzBuilder methodsFor: 'inputs' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:06'!
input
	"input factory method"
	| in |
	in := RzInput new.
	inputs add: in.
	^ in! !

!RzBuilder methodsFor: 'inputs' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:31'!
inputs
	"return all inputs in muldimensional context"
	^ inputs! !

!RzBuilder methodsFor: 'inputs' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:31'!
inputsOf: aSymbol 
	"return all posible values for a input with simbol aSymbol"
	| result |
	result := inputs
				select: [:in | in name = aSymbol].
	result size = 0
		ifTrue: [^ nil].
	^ result anyOne values! !

!RzBuilder methodsFor: 'hook' stamp: 'JuanPabloSandovalA 6/24/2012 21:53'!
load: version fromPackageCache: path
	"load cache version"
	| repo |
  	repo := MCDirectoryRepository new.
  	repo directory: (FileDirectory on: path).
  	version repositoryOverrides: (OrderedCollection with: repo).
  	version load.! !

!RzBuilder methodsFor: 'profiling' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:30'!
profile: aBlock inPackagesMatching: regex 
	"profile the execution of the aBlock in packages that mach with regex expresion"
	^ self spyProfiler profile: aBlock inPackagesMatching: regex! !

!RzBuilder methodsFor: 'profiling' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:19'!
spyProfiler
	"return the default spy profiler"
	^ RzProfilerSpy! !

Object subclass: #RzInput
	instanceVariableNames: 'name values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Builder'!

!RzInput class methodsFor: 'factory' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 19:00'!
named: aStringOrSymbol
	| instance |
	instance := self new.
	instance name: aStringOrSymbol.
	^ instance.! !

!RzInput methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 19:00'!
addValue: anObject
	values add: anObject! !

!RzInput methodsFor: 'accessing' stamp: ''!
initialize
	super initialize.
	values := OrderedCollection new! !

!RzInput methodsFor: 'accessing' stamp: ''!
name
	^ name! !

!RzInput methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 19:00'!
name: aStringOrSymbol
	name := aStringOrSymbol! !

!RzInput methodsFor: 'accessing' stamp: ''!
values
	^ values! !

!RzInput methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 19:00'!
values: aStringOrSymbol 
	values := aStringOrSymbol! !

Object subclass: #RzResultSet
	instanceVariableNames: 'dictionary size keys values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Builder'!

!RzResultSet methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:07'!
at: key
	"return the value associate to the key"
	| collectionkey |
	collectionkey := key isCollection
				ifTrue: [key]
				ifFalse: [OrderedCollection new add: key;
						 yourself].
	^ dictionary at: (RzVector values: collectionkey) ifAbsent: [ nil ].! !

!RzResultSet methodsFor: 'accessing' stamp: ''!
initialize
	super initialize.
	dictionary := Dictionary new.
	size := -1.
	keys := OrderedCollection new.
	values := OrderedCollection new! !

!RzResultSet methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:50'!
key: vector value: value
	"build a new association between key and value"
	|key|
	vector isCollection 
		ifTrue:[ key:= vector]
		ifFalse:[ key := (OrderedCollection new add:vector;yourself). ].
	size < 0
		ifTrue: [size := key size]
		ifFalse: [self assert: (key size = size)].
	keys add: (RzVector values: key).
	values add: value.
	dictionary at: (RzVector values: key) put: value.! !

!RzResultSet methodsFor: 'accessing' stamp: ''!
keys
	^ keys! !

!RzResultSet methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/24/2012 19:28'!
maxValue: aBlock 
	^ values maxValue: aBlock! !

!RzResultSet methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/29/2012 18:52'!
minValue: aBlock
	|min|
	min := self maxValue: aBlock.
	values do:[ :val|  (val < min ) ifTrue:[ min :=  val]].
	
	^ min.! !

!RzResultSet methodsFor: 'accessing' stamp: ''!
values
	^ values! !
